/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by webpigeon on 11/09/22.
//


#ifdef __GNUG__
	#include <cstdlib>
	#include <memory>
	#include <cxxabi.h>

	namespace fggl::debug {
		std::string demangle(const char *name) {
			int status = -4;

			std::unique_ptr<char, decltype(&std::free)> res{
				abi::__cxa_demangle(name, nullptr, nullptr, &status),
				std::free
			};

			return (status == 0) ? res.get() : name;
		}
	}
#else
	namespace fggl::debug {
		std::string demangle(const char* name) {
			return name;
		}
	}
#endif
