/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by webpigeon on 17/04/22.
//

#ifndef FGGL_GFX_OGL4_CANVAS_HPP
#define FGGL_GFX_OGL4_CANVAS_HPP

#include "fggl/gfx/paint.hpp"
#include "fggl/gfx/ogl/types.hpp"
#include "fggl/gfx/interfaces.hpp"

#include "fggl/gui/fonts.hpp"

namespace fggl::gfx::ogl4 {

	class CanvasRenderer {
		public:
			CanvasRenderer(gui::FontLibrary *fonts);
			void render(GLuint shader, const gfx::Paint &paint);

			inline gfx::Bounds bounds() const {
				return m_bounds;
			}

		private:
			gfx::Bounds m_bounds;
			ogl::VertexArray m_vao;
			ogl::ArrayBuffer m_vertexList;
			ogl::ElementBuffer m_indexList;
			gui::FontLibrary *m_fonts;
			ogl::Texture m_fontTex;

			void renderShapes(const Paint &paint, GLuint shader);
			void renderText(const Paint &, GLuint shader);
	};

} // namespace fggl::gfx::ogl4

#endif //FGGL_GFX_OGL4_CANVAS_HPP
