/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by webpigeon on 30/05/22.
//

#include "../include/fggl/phys/bullet/phys_draw.hpp"
#include "fggl/debug/draw.hpp"

#include <iostream>

namespace fggl::debug {

	using btdd = debug::BulletDebugDrawList;

	void btdd::drawLine(const btVector3 &from,
				  const btVector3 &to,
				  const btVector3 &fromColour,
				  const btVector3 &toColour) {
		dd::line(from, to, fromColour);
	}

	void btdd::drawLine(const btVector3 &from, const btVector3 &to, const btVector3 &colour)  {
		dd::line(from, to, colour);
	}

	void btdd::drawSphere(const btVector3 &p, btScalar radius, const btVector3 &color) {
		dd::sphere(p, color, radius);
	}

	void btdd::drawTriangle(const btVector3 &a,
					  const btVector3 &b,
					  const btVector3 &c,
					  const btVector3 &color,
					  btScalar alpha) {
		dd::line(a, b, color);
		dd::line(b, c, color);
		dd::line(c, a, color);
	}

	void btdd::drawContactPoint(const btVector3 &PointOnB,
						  const btVector3 &normalOnB,
						  btScalar distance,
						  int lifeTime,
						  const btVector3 &color) {

	}

	void btdd::reportErrorWarning(const char *warningString)  {
		std::cerr << warningString << std::endl;
	}

	void btdd::draw3dText(const btVector3 &location, const char *textString) {
		dd::screenText(textString, location, dd::colors::Wheat);
	}

	BulletDebugDrawList::BulletDebugDrawList() : m_mode( DBG_DrawAabb ) {

	}

}